# Changelog

All notable changes to this project will be documented in this file.
The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## Releases

---

## [4.1.1] - 2022-12-19

### Fixed

- fixed update to apollo server 3

---

## [4.1.0] - 2022-08-09

### Added

- changed failure route logic to redirect to login route

---

## [4.0.1] - 2022-08-09

### Security

- Upgraded Graphql-upload-minimal to next version to resolve typing errors

---

## [4.0.0] - 2022-08-09

### Security

- Upgraded from Apollo server 2 to Apollo server 3 to resolve security vulnerabilities
- Moved from Graphql-upload to Graphql-upload-minimal to resolve security vulnerabilites

---

## [3.6.0] - 2022-08-01

### Security

- Upgraded passport to resolve security vulnerabilities

---

## [3.5.0] - 2022-06-14

### Added

- removing the no longer maintain IBM OpenId strategy
- Using passport-openidconnect a library that is an OpenID Connect authentication strategy to authenticates users

---

## [3.4.3] - 2022-04-26

### Fixed

- passport race condition that occurs when multiple logins are sent to the server in an environment running multiple replicas

---

## [3.4.2] - 2022-04-14

### Fixed

- graphql upload capabilities
- added example/test of graphql uploading

---

## [3.4.1] - 2022-04-11

### Fixed

- graphql upload capabilities
- node 14 and apollo server 2 compatibility issue fixed

---

## [3.4.0] - 2022-04-07

### Added

- graphql upload capabilities
- add npm graphql-upload package

---

## [3.3.2] - 2022-03-31

### Security

- Minor upgrade to swagger-ui-express
- upgraded npm packages to fix audit warnings where possible

---

## [3.3.1] - 2022-03-17

### Fixed

- Updated manifest file to address vulnerabilities

---

## [3.3.0] - 2022-02-28

Added feature that allows developer to provide middleware on the serve static route

---

## [3.2.0] - 2022-02-18

Added optional context property to graphQLConfig

---

## [3.1.1] - 2022-02-03

Removed auth requirement for site notice route

---

## [3.1.0] - 2021-11-30

### Added

- Extended `addBluegroups` to allow for the adding of an arbitrary number of roles to a new or existing bluegroup in the server config
- Exported a new `ensureBasicAuth` middleware function

## [3.0.1] - 2021-11-29

### Security

- Minor updates to npm packages to fix audit warnings where possible

## [3.0.0] - 2021-11-11

### Breaking Changes

- The config object no longer has a `policies` property added by its methods. It now creates a `common` property instead.
- Mongoose upgraded to v6. If you consume a MongoClient exported from the template, you may need to update your implementation. See [mongoose migration guide](https://mongoosejs.com/docs/migrating_to_6.html) for more details.

### Deprecations

- Node.js < v12.0.0 is no longer supported

### Added

- Maintenance Mode: This optional feature will allow you to check common-services for app status before determining whether or not to serve the maintenance or index html.

### Security

- Fix multiple npm security warnings by upgrading mongoose, jest, fetch and other dependencies.

### Fixed

- Patched implementation of site-notice
- Reduced number of unnecessary exports when publishing

## [2.8.0] - 2021-11-9

### Added

- /site-notice route. A GET request that returns notices for a given offeringId from ies-dashboard-service. To enable route, developers must utilize the ApplicationConfig method `useDashboardNotice`, providing an `offeringId` and add varible named `DASHBOARD_SERVICE_API` to the projects env.

## [2.7.0] - 2021-10-1

### Added

- Added the HelpDesk role to the middleware user model

## [2.6.0] - 2021-09-27

### Added

- New application configuration property, REQUIRE_LOGIN (basicConfig.app.requireLogin). When this property is set to true, handleLogin middleware will be included in the application's default middleware

## [2.5.0] - 2021-08-30

### Added

- Enabled handling of 204 responses, which have no content to return

## [2.4.0] - 2021-08-30

### Added

- In memory mongo client to be used for router testing

- Configuration for HTTP / HTTPS application

- getMongoConnection function that returns specified mongo connection

### Fixed

- Error caused by npm version update. Set default value for npm_package_description

- Error with parseBoolean function not returning expected value

## [2.3.0] - 2021-07-27

### Added

- User details to request object when a user is authenticated by introspection

### Changed

- Minor implementation details of certain functions to accommodate optional id property on the base model

## [2.2.0] - 2021-06-28

### Changed

- Helmet now enforces less stringent security headers
- Server error now passes up the entire message in production if the error object has one

### Fixed

- Server error is now correctly called by middleware

## [2.1.0] - 2021-06-22

### Added

- setBasicAuth method to the ApplicationConfig

### Changed

- usePolicies - calls setBasicAuth with the provided username and password

### Removed

- username and password properties from policy configuration / replaced with basicAuth.username and basicAuth.pass when a user calls the setBasicAuth or the usePolicies method

## [2.0.0] - 2021-06-18

### Changed

- IesTemplateServer constructor to allow for middleware options - note that this will break graphQl consumers configuration
- Swagger config
- apiRequestor interface to handle third argument for fetchJson

### Added

- Custom option for consumers to create a custom config

## [2.0.0-test] - 2021-05-21

### Updated

- Major and minor packages in manifest file

### Added

- Ability to expose swagger configuration
- Default empty string to config variables

### Changed

- middleware configuration (graphQL, swagger) now exposed in template constructor

## [1.3.0] - 2021-05-05

### Added

- expanded authUser to check for bluegroup roles Product Owner, Devops and Developer

## [1.2.0] - 2021-04-27

### Added

- w3id introspection on access tokens when being used as a backend service

- default urls in env.config

## [1.1.0] - 2021-04-22

### Added

- graphql support

- mongodb support

- added two scripts that will run tests groups by file extension

### Changed

- moved types from devDependency to dependency

### Removed

- secrets from logs

## [1.0.20] - 2021-01-05

### Added

- jsDocs for authentication middleware functions

- updated /api README.md with information on authentication middleware usage

## [1.0.19] - 2020-12-09

### Added

- export statement of the fetchJsonWithoutDefaultContentType method for the APIRequester interface

## [1.0.18] - 2020-12-09

### Added

- new fetchJsonWithoutDefaultContentType method to the HttpApiJsonRequester class

## [1.0.17] - 2020-11-20

### Changed

- ISV package version due to security vulnerability

### Removed

- unused certificates

## [1.0.16] - 2020-10-19

### Added

- new isAuditor property on user-model, determined by env file

## [1.0.15] - 2020-10-15

### Added

- new remote-test env configs for Travis CI

## [1.0.14] - 2020-10-07

### Added

- Optional custom api error transformer for fetchJson
- Enhanced error logging for apiRequester
- Fixed english grammar in messaging

## [1.0.13] - 2020-09-30

### Changed

- Identity provider to IBM Security Verify in OIDC Strategy

### Removed

- unused w3id env vars from env config

## [1.0.12] - 2020-09-29

### Added

- bypassAppUserAuth for developers to specify that app should not check user groups for app access

## [1.0.11] - 2020-09-17

### Added

- user policy verification logic to isLoggedin api
- legalException error rest creating HTTP451Error status

### Fixed

- Redirect location typo in Auth Middleware

## [1.0.10] - 2020-09-14

### Added

- Oidc prod cert to oidc strategy

### Changed

- Reverted verification middleware Error Handling
- Passport failure handling

## [1.0.9] - 2020-09-11

### Changed

- Verification middleware Error Handling

## [1.0.8] - 2020-09-9

### Added

- Unauthorized redirect API

### Changed

- isLoggedIn to throw client authentication errors instead of returning a null user object

## [1.0.7] - 2020-08-28

### Added

- Authorization check from bluegroups on isLoggedIn

## [1.0.6] - 2020-08-25

### Removed

- return next call in policyCheck route

### Added

- logging to debug policyCheck route

## [1.0.5] - 2020-08-21

### Removed

- isProduction Proxy Guard

## [1.0.4] - 2020-08-18

### Fixed

- Redis connection

### Changed

- Expanded AuthUser type attribute fields for W3 ID
- Refactored setuptests
- Exported setupGlobal util
- Refactored env ts into function
- Exported new env initLocalEnv util for module

### Added

- Added peer dependencies since module export on validators had named export conflict

### Removed

- Unused packages

## [1.0.3] - 2020-08-05

### Added

- ensureAuthUser middleware

## [1.0.2] - 2020-08-04

### Changed

- Applied common ies team node typescript linter to entire project

## [1.0.1] - 2020-07-31

### Added

- MiddlewareError type

### Fixed

- Client error handler now handles external api errors

### Changed

- Api requester statusCode typing to not be undefined

## [1.0.0] - 2020-07-29

### Added

- IesTemplateServer
- Refactored /common/\* to use named exports
- Refactored /utils/\* to use named exports
- Refactored /config/\* to use named exports
- Exported /common/\* components
- Exported /utils/\* components
- Exported /config/\* components
- Exported ensureAuthenticated component
- Feature - Acknowledge Privacy Agreement
- Feature - /logout destroys session
- Feature - /isLoggedin returns user object

### Removed

- /lib folder

---
