"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractSecureRestProvider = exports.AbstractRestProvider = void 0;
const apiRequester_utils_1 = require("./../../utils/api/apiRequester.utils");
// eslint-disable: max-classes-per-file
class AbstractRestProvider {
    constructor(options) {
        const allOptions = Object.assign(Object.assign({}, this.defaultRequestOptions), options);
        this.requester = new apiRequester_utils_1.HttpApiJsonRequester(this.constructor.name, allOptions);
    }
}
exports.AbstractRestProvider = AbstractRestProvider;
class AbstractSecureRestProvider extends AbstractRestProvider {
    constructor(accessToken) {
        super({
            headers: apiRequester_utils_1.HttpApiJsonRequester.oauth2Header(accessToken),
        });
    }
}
exports.AbstractSecureRestProvider = AbstractSecureRestProvider;
