"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractRestRouter = void 0;
const express_1 = require("express");
class AbstractRestRouter {
    constructor() {
        this.router = express_1.Router();
    }
    getBasePath() {
        return this.basePath;
    }
    getRouter() {
        return this.router;
    }
    handleRouteParam(controller, handler) {
        return (req, res, next, param) => {
            return Promise.resolve(handler.bind(controller)(req, res, next, param)).catch((err) => next(err));
        };
    }
    handleRoute(controller, handler) {
        return (req, res, next) => {
            const noParam = "";
            return Promise.resolve(handler.bind(controller)(req, res, next, noParam)).catch((err) => next(err));
        };
    }
}
exports.AbstractRestRouter = AbstractRestRouter;
