"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TokenProvider = void 0;
const config_1 = require("../../../../config");
const __1 = require("../../..");
class TokenProvider extends __1.AbstractRestProvider {
    constructor() {
        super(...arguments);
        this.apiUrl = config_1.baseConfig.openid.token_url;
    }
    getToken(body) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.requester.fetchJsonWithoutDefaultContentType(this.apiUrl, {
                headers: {
                    "Content-Type": "application/x-www-form-urlencoded",
                },
                method: "POST",
                body,
            });
        });
    }
}
exports.TokenProvider = TokenProvider;
