"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Notices = void 0;
const model_api_1 = require("../../data/model.api");
const Notice_model_1 = require("./Notice.model");
class Notices extends model_api_1.Model {
    constructor(data) {
        super(data.id);
        this.notices = [];
        this.notices = this._modelNotices(data);
    }
    // Takes in an an array of notices (unmodeled), need type any to avoid property map does not exist error
    _modelNotices(notices) {
        return notices.map((notice) => {
            return new Notice_model_1.Notice(notice);
        });
    }
    toJSON() {
        return {
            notices: this.notices,
        };
    }
}
exports.Notices = Notices;
/**
 * @swagger
 *  components:
 *    schemas:
 *      Notices:
 *        type: object
 *        properties:
 *          notices:
 *            type: array
 *            items:
 *              $ref: '#/components/schemas/Notice'
 */
