"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteNoticeProvider = void 0;
const mongodb_1 = require("mongodb");
const __1 = require("../../../..");
const config_1 = require("../../../../config");
const __2 = require("../../..");
class SiteNoticeProvider extends __2.AbstractRestProvider {
    constructor() {
        var _a, _b, _c, _d;
        super(...arguments);
        this.apiUrl = (_b = (_a = config_1.ApplicationConfig.get()) === null || _a === void 0 ? void 0 : _a.dashboardService) === null || _b === void 0 ? void 0 : _b.api;
        this.offeringId = (_d = (_c = config_1.ApplicationConfig.get()) === null || _c === void 0 ? void 0 : _c.dashboardService) === null || _d === void 0 ? void 0 : _d.offeringId;
    }
    getNotices() {
        const body = {
            startDate: {
                date: new Date().toISOString(),
                filter: "$lte",
            },
            endDate: {
                date: new Date().toISOString(),
                filter: "$gte",
            },
            offeringId: new mongodb_1.ObjectId(this.offeringId),
            deleted: false,
        };
        const options = __1.HttpApiJsonRequester.postJson(body);
        return this.requester.fetchJson(`${this.apiUrl}/notices/search`, options);
    }
}
exports.SiteNoticeProvider = SiteNoticeProvider;
