"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteNoticeController = void 0;
const __1 = require("../..");
const Notices_model_1 = require("./Notices.model");
const providers_1 = require("./providers");
class SiteNoticeController extends __1.AbstractRestController {
    getSiteNotices(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            SiteNoticeController.LOGGER.debug("Retrieving all Site Notices");
            const noticeProvider = new providers_1.SiteNoticeProvider({});
            const noticesMongo = yield noticeProvider.getNotices();
            const notices = new Notices_model_1.Notices(noticesMongo);
            return Promise.resolve(this.respond(res, notices));
        });
    }
}
exports.SiteNoticeController = SiteNoticeController;
SiteNoticeController.LOGGER = __1.logger.child("Site Notice");
