"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleAPIDocs = void 0;
const swagger_jsdoc_1 = __importDefault(require("swagger-jsdoc"));
const swagger_ui_express_1 = __importDefault(require("swagger-ui-express"));
const config_1 = require("../config");
const middleware_api_1 = require("./middleware.api");
const handleAPIDocs = (router, swaggerOptions = config_1.SwaggerOptions, uiOptions = { explorer: true }) => {
    middleware_api_1.logMiddlewareStart("Api Docs");
    const path = `${config_1.baseConfig.app.apiBasePath}${config_1.swaggerBasePath}`;
    const docs = swagger_jsdoc_1.default(swaggerOptions);
    router.use(path, swagger_ui_express_1.default.serve, swagger_ui_express_1.default.setup(docs, uiOptions));
};
exports.handleAPIDocs = handleAPIDocs;
