"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateUserWithServiceIdApi = void 0;
const apiRequester_utils_1 = require("../../utils/api/apiRequester.utils");
// TODO refactor into router / service framework along with the other verification middleware
// TODO need to create return type, interface, and/or model
const validateUserWithServiceIdApi = (email, config) => __awaiter(void 0, void 0, void 0, function* () {
    const basicAuth = apiRequester_utils_1.HttpApiJsonRequester.basicAuth(config.basicAuth.username, config.basicAuth.pass);
    const policiesRequester = new apiRequester_utils_1.HttpApiJsonRequester("policies", {
        headers: basicAuth,
    });
    return policiesRequester.fetchJson(`${config.common.policiesApi}/user/service/?email=${email}&serviceId=${config.common.serviceId}`);
});
exports.validateUserWithServiceIdApi = validateUserWithServiceIdApi;
