"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthenticatedUser = void 0;
const class_validator_1 = require("class-validator");
const model_api_1 = require("../../common/data/model.api");
const auth_utils_1 = require("../../utils/auth.utils");
class AuthenticatedUser extends model_api_1.Model {
    constructor(data) {
        super(data.id);
        const { blueGroups, firstName, lastName, emailAddress } = data._json;
        this._firstName = firstName;
        this._lastName = lastName;
        this._email = emailAddress;
        this._isAdmin = auth_utils_1.isAdministrator(blueGroups);
        this._isAuthorized = auth_utils_1.isAuthorizedUser(blueGroups);
        this._isAuditor = auth_utils_1.isAuditor(blueGroups);
        this._isDevOps = auth_utils_1.isDevOps(blueGroups);
        this._isPO = auth_utils_1.isPO(blueGroups);
        this._isExternal = auth_utils_1.isExternal(blueGroups);
        this._isTeamMember = auth_utils_1.isTeamMember(blueGroups);
        this._isHelpDesk = auth_utils_1.isHelpDeskUser(blueGroups);
    }
    get email() {
        return this._email;
    }
    get isAuthorized() {
        return this._isAuthorized;
    }
    get isAdmin() {
        return this._isAdmin;
    }
    toJSON() {
        return {
            id: this.id,
            firstName: this._firstName,
            lastName: this._lastName,
            isAdmin: this._isAdmin,
            isAuditor: this._isAuditor,
            isDevOps: this._isDevOps,
            isPO: this._isPO,
            isExternal: this._isExternal,
            isTeamMember: this._isTeamMember,
            isHelpDeskUser: this._isHelpDesk,
        };
    }
}
__decorate([
    class_validator_1.IsEmail(),
    __metadata("design:type", String)
], AuthenticatedUser.prototype, "_email", void 0);
exports.AuthenticatedUser = AuthenticatedUser;
