"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleCompression = exports.handleBodyRequestParsing = exports.handleCors = void 0;
const body_parser_1 = __importDefault(require("body-parser"));
const compression_1 = __importDefault(require("compression"));
const cors_1 = __importDefault(require("cors"));
const middleware_api_1 = require("./middleware.api");
const handleCors = (router) => {
    middleware_api_1.logMiddlewareStart("Cors");
    router.use(cors_1.default({ credentials: true, origin: true }));
};
exports.handleCors = handleCors;
const handleBodyRequestParsing = (router) => {
    middleware_api_1.logMiddlewareStart("Json Body Parsing");
    router.use(body_parser_1.default.urlencoded({ extended: true }));
    router.use(body_parser_1.default.json());
};
exports.handleBodyRequestParsing = handleBodyRequestParsing;
const handleCompression = (router) => {
    middleware_api_1.logMiddlewareStart("Compression");
    router.use(compression_1.default());
};
exports.handleCompression = handleCompression;
