"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleGraphQL = void 0;
const apollo_server_express_1 = require("apollo-server-express");
const graphql_upload_minimal_1 = require("graphql-upload-minimal");
const middleware_api_1 = require("./middleware.api");
// TODO investigate why app Application type does not match with apollo's version
const handleGraphQL = (app, graphQLConfig) => __awaiter(void 0, void 0, void 0, function* () {
    middleware_api_1.logMiddlewareStart("GraphQL");
    const path = `/${graphQLConfig.rootPath}`;
    const options = Object.assign({
        typeDefs: graphQLConfig.typeDefs,
        resolvers: graphQLConfig.resolvers,
    }, graphQLConfig.context && { context: graphQLConfig.context }, graphQLConfig.uploads !== undefined && { uploads: graphQLConfig.uploads });
    const server = new apollo_server_express_1.ApolloServer(options);
    yield server.start();
    app.use(graphql_upload_minimal_1.graphqlUploadExpress());
    server.applyMiddleware({ app, path });
});
exports.handleGraphQL = handleGraphQL;
