"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleRequestId = void 0;
const uuid_1 = require("uuid");
const middleware_api_1 = require("./middleware.api");
const handleRequestId = (router) => {
    const HEADER_NAME = "X-Request-Id";
    middleware_api_1.logMiddlewareStart("Request Id");
    router.use((req, res, next) => {
        const reqWithId = req;
        reqWithId.id =
            req.headers[HEADER_NAME.toLowerCase()] || uuid_1.v5(req.url, uuid_1.v5.URL);
        res.setHeader(HEADER_NAME, reqWithId.id);
        next();
    });
};
exports.handleRequestId = handleRequestId;
