"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AssociationRouter = void 0;
const restRouter_api_1 = require("../../common/rest/restRouter.api");
const auth_middleware_1 = require("../../middleware/auth/auth.middleware");
const association_controller_1 = require("./association.controller");
class AssociationRouter extends restRouter_api_1.AbstractRestRouter {
    constructor() {
        super();
        this.basePath = "/associations";
        this.controller = new association_controller_1.AssociationController();
        this.initRoutes();
    }
    initRoutes() {
        const c = this.controller;
        this.router.get("/", auth_middleware_1.ensureAuthenticated, c.queryValidator(), this.handleRoute(c, c.getAssociations));
    }
}
exports.AssociationRouter = AssociationRouter;
