"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommonController = void 0;
const common_1 = require("../../common");
const commonService_model_1 = require("./commonService.model");
const commonServices_provider_1 = require("./providers/commonServices.provider");
class CommonController extends common_1.AbstractRestController {
    getCommonServiceById(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            CommonController.LOGGER.debug("Retrieving all CommonServicesRecords");
            const targetApplication = req.params.app;
            const commonServicesProvider = new commonServices_provider_1.CommonServicesProvider({});
            const data = yield commonServicesProvider.getServiceById(targetApplication);
            const modeledRecord = new commonService_model_1.CommonServicesRecord(data);
            return Promise.resolve(this.respond(res, modeledRecord));
        });
    }
}
exports.CommonController = CommonController;
CommonController.LOGGER = common_1.logger.child("common");
