"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommonRouter = void 0;
const restRouter_api_1 = require("../../common/rest/restRouter.api");
const common_controller_1 = require("./common.controller");
/**
 * @swagger
 * tags:
 *   name: Common
 *   description: Common Services management
 */
class CommonRouter extends restRouter_api_1.AbstractRestRouter {
    constructor() {
        super();
        this.basePath = "/v1/common";
        this.controller = new common_controller_1.CommonController();
        this.initRoutes();
    }
    initRoutes() {
        const c = this.controller;
        /**
         * @swagger
         * /v1/common/{application}:
         *  get:
         *   summary: Get application record from common-services by application name
         *   parameters:
         *    - in: path
         *      name: application
         *      schema:
         *        type: string
         *      required: true
         *      description: Target application to be retrieved
         *   security:
         *    - []
         *   tags: [Common]
         *   responses:
         *    200:
         *     description: Application Record
         *     content:
         *      application/json:
         *       schema:
         *        $ref: '#/components/schemas/CommonServicesRecord'
         */
        this.router.get("/:app", this.handleRoute(c, c.getCommonServiceById));
    }
}
exports.CommonRouter = CommonRouter;
