"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommonServicesRecord = void 0;
const model_api_1 = require("../../common/data/model.api");
// tslint:disable: variable-name
class CommonServicesRecord extends model_api_1.Model {
    constructor(data) {
        super(data === null || data === void 0 ? void 0 : data.id);
        this.announcement = data === null || data === void 0 ? void 0 : data.announcement;
        this.status = data === null || data === void 0 ? void 0 : data.status;
        this.accessGroup = data === null || data === void 0 ? void 0 : data.accessGroup;
        this.checkPolicy = data === null || data === void 0 ? void 0 : data.checkPolicy;
        this.description = data === null || data === void 0 ? void 0 : data.description;
        this.gdprGroup = data === null || data === void 0 ? void 0 : data.gdprGroup;
        this.keywords = data === null || data === void 0 ? void 0 : data.keywords;
        this.team = data === null || data === void 0 ? void 0 : data.team;
        this.type = data === null || data === void 0 ? void 0 : data.type;
        this.underMaintenance = data === null || data === void 0 ? void 0 : data.underMaintenance;
        this.url = data === null || data === void 0 ? void 0 : data.url;
        this._id = data === null || data === void 0 ? void 0 : data._id;
        this.serviceId = data === null || data === void 0 ? void 0 : data.serviceId;
        this.name = data === null || data === void 0 ? void 0 : data.name;
        this.__v = data === null || data === void 0 ? void 0 : data.__v;
    }
    toJSON() {
        return {
            announcement: this.announcement,
            status: this.status,
            accessGroup: this.accessGroup,
            checkPolicy: this.checkPolicy,
            description: this.description,
            gdprGroup: this.gdprGroup,
            keywords: this.keywords,
            team: this.team,
            type: this.type,
            underMaintenance: this.underMaintenance,
            url: this.url,
            _id: this._id,
            serviceId: this.serviceId,
            name: this.name,
            __v: this.__v,
        };
    }
}
exports.CommonServicesRecord = CommonServicesRecord;
/**
 * @swagger
 *  components:
 *    schemas:
 *      Announcement:
 *        type: object
 *        properties:
 *          message:
 *            type: string
 *          enabled:
 *            type: boolean
 *      Status:
 *        type: object
 *        properties:
 *          statusCode:
 *            type: number
 *          timestamp:
 *            type: number
 *      CommonServicesRecord:
 *        type: object
 *        properties:
 *          announcement:
 *            $ref: '#/components/schemas/Announcement'
 *          status:
 *            $ref: '#/components/schemas/Status'
 *          accessGroup:
 *            type: array
 *            items:
 *              nullable: true
 *          checkPolicy:
 *            type: boolean
 *          description:
 *            type: string
 *          gdprGroup:
 *            type: array
 *            items:
 *              nullable: true
 *          keywords:
 *            type: array
 *            items:
 *              nullable: true
 *          team:
 *            type: string
 *          type:
 *            type: string
 *          underMaintenance:
 *            type: boolean
 *          url:
 *            type: string
 *          _id:
 *            type: string
 *          serviceId:
 *            type: string
 *          name:
 *            type: string
 *          __v:
 *            type: number
 */
