"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.graphResolver = void 0;
const graphql_upload_minimal_1 = require("graphql-upload-minimal");
const graph_model_1 = require("./graph.model");
exports.graphResolver = {
    Upload: graphql_upload_minimal_1.GraphQLUpload,
    Mutation: {
        singleUpload: (root, args) => __awaiter(void 0, void 0, void 0, function* () {
            const { createReadStream, filename, mimetype, encoding } = yield args.file;
            // Invoking the `createReadStream` will return a Readable Stream.
            // See https://nodejs.org/api/stream.html#stream_readable_streams
            const stream = createReadStream();
            return { filename, mimetype, encoding };
        }),
    },
    Query: {
        hello: () => __awaiter(void 0, void 0, void 0, function* () {
            const name = "Test";
            const Graph = new graph_model_1.GraphModel({ name });
            yield Graph.save();
            const graph = yield graph_model_1.GraphModel.findOne({
                name,
            }).exec();
            yield Graph.delete();
            return graph === null || graph === void 0 ? void 0 : graph.name;
        }),
    },
};
