"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const config_1 = require("../../../config");
const apiRequester_utils_1 = require("../../../utils/api/apiRequester.utils");
class GithubProvider {
    constructor() {
        var _a;
        this.requester = new apiRequester_utils_1.HttpApiJsonRequester("github");
        this.api = (_a = config_1.ApplicationConfig.get().api) === null || _a === void 0 ? void 0 : _a.github;
    }
    findOrg(org) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.requester.fetchJson(`${this.api}/orgs/${org}`);
        });
    }
}
exports.default = GithubProvider;
