"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.User = void 0;
const class_validator_1 = require("class-validator");
const common_1 = require("../../common");
class User extends common_1.Model {
    constructor(data) {
        super(data === null || data === void 0 ? void 0 : data.id);
        this.email = data === null || data === void 0 ? void 0 : data.email;
        this.name = data === null || data === void 0 ? void 0 : data.name;
        this.status = (data === null || data === void 0 ? void 0 : data.status) || "Happy";
        this.phoneNumbers = data === null || data === void 0 ? void 0 : data.phoneNumbers;
    }
    toJSON() {
        return {
            id: this.id,
            email: this.email,
            name: this.name,
            status: this.status,
            phoneNumbers: this.phoneNumbers,
        };
    }
}
__decorate([
    class_validator_1.IsEmail(),
    __metadata("design:type", String)
], User.prototype, "email", void 0);
exports.User = User;
// /**
//  * @swagger
//  *  components:
//  *    schemas:
//  *      User:
//  *        type: object
//  *        required:
//  *          - id
//  *          - email
//  *          - name
//  *          - phoneNumbers
//  *        properties:
//  *          id:
//  *            type: string
//  *            format: uuid
//  *          name:
//  *            type: string
//  *          email:
//  *            type: string
//  *            format: email
//  *            description: Email for the user, needs to be unique.
//  *        example:
//  *           name: Alexander
//  *           email: fake@email.com
//  */
