"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("./env");
require("./applyConfig");
const fs_1 = __importDefault(require("fs"));
const app_root_path_1 = __importDefault(require("app-root-path"));
const figlet_1 = __importDefault(require("figlet"));
const common_1 = require("./common");
const services_1 = require("./common/services");
const config_1 = require("./config");
const services_2 = require("./services");
const templateServer_1 = require("./templateServer");
// TODO move into template server and make name configurable based on the project that uses the template
const TEMPLATE_SHOWCASE_TITLE = figlet_1.default.textSync("Ies Node Api Template", {
    horizontalLayout: "default",
    verticalLayout: "default",
});
common_1.logger.log(`\n${TEMPLATE_SHOWCASE_TITLE}\n`);
const https = {
    key: fs_1.default.readFileSync(`${app_root_path_1.default}/cert/key.pem`),
    cert: fs_1.default.readFileSync(`${app_root_path_1.default}/cert/cert.pem`),
};
const graphQLConfig = {
    rootPath: "graph",
    typeDefs: services_2.typeDefs,
    resolvers: services_2.resolvers,
    uploads: false,
};
const allRoutes = [...services_2.routes, services_1.ProxyRoutes, services_1.SiteNoticeRoutes];
const middlewareOptions = {
    graphQLConfig,
    swagger: config_1.customSwaggerOptions,
    preApiRouterMiddleware: {
        handleHttpGuard: {
            contentSecurityPolicy: false,
            expectCt: { enforce: false },
            referrerPolicy: false,
        },
    },
};
const server = new templateServer_1.IesTemplateServer(allRoutes, https, middlewareOptions);
server.start();
// OPTIONS
// Config file instantiates config class and modifies it for app in template
//
