"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatProfile = void 0;
const formatProfile = (res, issuer, accessToken, refreshToken) => {
    const user = {
        id: "",
        displayName: "",
        tenantId: "",
        _json: {
            blueGroups: [],
            firstName: "",
            lastName: "",
            emailAddress: "",
            accessToken: "",
            refreshToken: "",
            cn: "",
            dn: "",
            uid: "",
            sub: "",
            realmName: "",
            iss: "",
        },
    };
    user.id = res.emailAddress;
    user.displayName = res.displayName;
    user.tenantId = res.ext.tenantId;
    user._json.blueGroups = Array.from(res.blueGroups);
    user._json.firstName = res.firstName;
    user._json.lastName = res.lastName;
    user._json.emailAddress = res.emailAddress;
    user._json.accessToken = accessToken;
    user._json.refreshToken = refreshToken;
    user._json.cn = res.cn;
    user._json.dn = res.dn;
    user._json.uid = res.uid;
    user._json.sub = res.sub;
    user._json.realmName = res.realmName;
    user._json.iss = issuer;
    return user;
};
exports.formatProfile = formatProfile;
