"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isApiRequest = exports.ApiRouterFactory = void 0;
const express_1 = require("express");
const common_1 = require("../common");
const config_1 = require("../config");
class ApiRouterFactory {
    static makeRouter(restRouters) {
        this.LOGGER.info(`Creating Router`.toUpperCase());
        const router = express_1.Router();
        restRouters.forEach((restRoute) => {
            this.LOGGER.info(`Adding Route: ${restRoute.getBasePath()}`);
            router.use(restRoute.getBasePath(), restRoute.getRouter());
        });
        return router;
    }
}
exports.ApiRouterFactory = ApiRouterFactory;
ApiRouterFactory.LOGGER = common_1.logger.child("Router Factory");
/**
 * Checks if the request is a /api request
 * @param req
 */
const isApiRequest = (req) => req.baseUrl === config_1.baseConfig.app.apiBasePath || // set if route is mounted
    req.url.startsWith(config_1.baseConfig.app.apiBasePath);
exports.isApiRequest = isApiRequest;
