"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initLocalEnv = void 0;
const app_root_path_1 = __importDefault(require("app-root-path"));
const command_line_args_1 = __importDefault(require("command-line-args"));
const dotenv_1 = __importDefault(require("dotenv"));
const initLocalEnv = () => {
    if (process.env.NODE_ENV !== "production" &&
        process.env.NODE_ENV !== "remote-test") {
        let options = {
            env: "",
        };
        if (process.env.NODE_ENV === "development") {
            /**
             * Setup command line options.
             * This is separate fron NODE_ENV so you can use production in dev for example
             *
             * Note: in a 12 factor app you should not have multiple env files
             * between deploys. Hence, this is used as a convenience for dev only
             *
             * WARNING: This will break jest tests so its restricted to development
             */
            options = command_line_args_1.default([
                {
                    name: "env",
                    alias: "e",
                    defaultValue: "",
                    type: String,
                },
            ]);
        }
        // Set the env file
        const path = `${app_root_path_1.default}/env/${options.env}.env`;
        const result = dotenv_1.default.config({ path });
        if (result.error) {
            throw result.error;
        }
    }
};
exports.initLocalEnv = initLocalEnv;
