"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseInteger = exports.parseBoolean = void 0;
const convertStringToBoolean = (value) => value === "true";
const isValidBoolean = (value) => {
    return (value === "true" || value === "false" || value === true || value === false);
};
const isValidInteger = (value) => {
    const parsedInt = parseInt(value, 10);
    return !isNaN(parsedInt);
};
const parseBoolean = (value, errorMessage) => {
    if (typeof value === "boolean")
        return value;
    if (!isValidBoolean(value)) {
        const message = errorMessage || `${value} is not a valid boolean!`;
        throw new Error(message);
    }
    return convertStringToBoolean(value);
};
exports.parseBoolean = parseBoolean;
const parseInteger = (value, errorMessage) => {
    if (!isValidInteger(value)) {
        const message = errorMessage || `${value} is not a valid int!`;
        throw new Error(message);
    }
    return parseInt(value, 10);
};
exports.parseInteger = parseInteger;
