import pino from "pino";
import { LoggerApi } from "./logger.api";
export declare class PinoLogger extends LoggerApi {
    private logger;
    private static _children;
    constructor(logger: pino.Logger);
    error(message: any, ...args: any): void;
    log(message: any, ...args: any): void;
    debug(message: any, ...args: any): void;
    info(message: any, ...args: any): void;
    warn(message: any, ...args: any): void;
    fatal(message: any, ...args: any): void;
    trace(message: any, ...args: any): void;
    child(component: string): LoggerApi;
    /**
     * When a Node process crashes from uncaught exception, exits due to a signal, or exits of it's own accord we may want to
     * write some final logs – particularly in cases of error. Writing to a Node.js stream on exit is not necessarily
     * guaranteed, and naively writing to an asynchronous logger on exit will definitely lead to lost log.
     *
     * The finalLogger is a special logger instance that will synchronously and reliably flush every log line.
     * This is important in exit handlers, since no more asynchronous activity may be scheduled.
     *
     * @param event
     * @param callback
     */
    exitHandler(event: string, callback: () => void): (error: Error | null, ...args: any[]) => void;
}
