"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PinoLoggerService = void 0;
const pino_1 = __importDefault(require("pino"));
const config_1 = require("../../config");
const logger_1 = require("./logger");
class PinoLoggerService extends logger_1.PinoLogger {
    constructor() {
        const [middleware, logger] = PinoLoggerService.buildLogger();
        super(logger);
        this.middleware = middleware;
    }
    /**
     * Builds pino logger to work with pino pretty and the express middleware
     * Issues: https://stackoverflow.com/questions/52557386/using-express-pino-logger-and-pino-pretty-together
     */
    static buildLogger() {
        const pinoOptions = {
            prettyPrint: { colorize: true },
            level: config_1.baseConfig.app.logLevel,
        };
        const pinoLogger = pino_1.default(pinoOptions);
        // Import type definitions missing...need to use require to access logger
        // eslint-disable-next-line @typescript-eslint/no-var-requires
        const expressPino = require("express-pino-logger")({
            logger: pinoLogger,
        });
        return [expressPino, expressPino.logger];
    }
}
exports.PinoLoggerService = PinoLoggerService;
