import { BusinessViolationCode } from "../../../businessRules/businessViolationCodes";
import { HTTPClientError } from "../error.api";
/**
 * This error is meant to be thrown when there is some application-specific business logic,
 * or data constraint that is violated by the request. These scenarios should be documented
 * by your API, and referenced a unique error identifier. The "businessViolationCode" attribute
 * can be used to store/serialize that unique error identifier.
 */
export declare class HTTP422Error extends HTTPClientError {
    businessViolationCode: BusinessViolationCode;
    private errors;
    readonly statusCode = 422;
    constructor(businessViolationCode: BusinessViolationCode, message?: string | Record<string, unknown>, errors?: Record<string, unknown>[]);
    toJSON(): Record<string, unknown>;
}
