import { Request, Response } from "express";
import { ValidationChain } from "express-validator";
import { RestPaginationStrategy } from "../restPaginationStrategy.api";
export declare type PaginatedHeaderData = {
    offset: string;
    count: string;
    limit: string;
};
export declare class OffsetPaginationStrategy implements RestPaginationStrategy {
    private static DEFAULT_PAGINATION_LIMIT;
    private static HEADER_OFFSET;
    private static HEADER_COUNT;
    private static HEADER_LIMIT;
    applyHeaders(res: Response, data: PaginatedHeaderData): void;
    resolveQuery(req: Request): Partial<PaginatedHeaderData>;
    queryValidator(): ValidationChain[];
}
