import { NextFunction, Request, Response, Router } from "express";
import { Model } from "../data/model.api";
import { AbstractRestController, ControllerMiddlewareMethod } from "./restController.api";
export interface RestRouter {
    getBasePath(): string;
    getRouter(): Router;
}
export declare abstract class AbstractRestRouter<M extends Model, C extends AbstractRestController<M>> implements RestRouter {
    protected readonly basePath: string;
    protected readonly router: Router;
    constructor();
    getBasePath(): string;
    getRouter(): Router;
    handleRouteParam(controller: C, handler: ControllerMiddlewareMethod): (req: Request, res: Response, next: NextFunction, param: string) => Promise<any>;
    handleRoute(controller: C, handler: ControllerMiddlewareMethod): (req: Request, res: Response, next: NextFunction) => Promise<any>;
    abstract initRoutes(): void;
}
