"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProxyController = void 0;
const config_1 = require("../../../config");
const __1 = require("../..");
const providers_1 = require("./providers");
const token_model_1 = require("./token.model");
class ProxyController extends __1.AbstractRestController {
    // JWT cannot be retrieved by the client, as the client secret needs to be added on the server and CORS errors prevent calling cross-domain
    getToken(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            ProxyController.LOGGER.debug("Requesting token in oauth flow");
            const body = req.body;
            // Structure data to be sent as form data
            let searchParams = Object.keys(body)
                .map((key) => {
                return encodeURIComponent(key) + "=" + encodeURIComponent(body[key]);
            })
                .join("&");
            searchParams += `&client_secret=${config_1.baseConfig.openid.client_secret}`;
            const provider = new providers_1.TokenProvider({}); // Auth not needed, default options
            const data = yield provider.getToken(searchParams);
            const token = new token_model_1.Token(data);
            return Promise.resolve(this.respond(res, token));
        });
    }
}
exports.ProxyController = ProxyController;
ProxyController.LOGGER = __1.logger.child("Proxy");
