"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.W3_OIDC_STRATEGY = void 0;
const passport_ci_oidc_1 = __importDefault(require("passport-ci-oidc"));
const config_1 = require("../../../config");
const OpenIDConnectStrategy = passport_ci_oidc_1.default.IDaaSOIDCStrategy;
exports.W3_OIDC_STRATEGY = new OpenIDConnectStrategy({
    discoveryURL: config_1.baseConfig.openid.discovery_url,
    clientID: config_1.baseConfig.openid.client_id,
    scope: "openid",
    response_type: "code",
    clientSecret: config_1.baseConfig.openid.client_secret,
    callbackURL: config_1.baseConfig.openid.callback_url,
    skipUserProfile: true,
    addCACert: true,
    // local: true,
    CACertPathList: [
        "/cert/DigiCertGlobalRootCA.crt",
        "/cert/DigiCertSHA2SecureServerCA.crt",
    ],
}, (iss, sub, profile, accessToken, refreshToken, params, done) => {
    process.nextTick(() => {
        // pass access token into jwt
        profile._json.accessToken = accessToken;
        profile._json.refreshToken = refreshToken;
        return done(null, profile);
    });
});
