"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PassportClient = void 0;
const passport_1 = __importDefault(require("passport"));
const middleware_api_1 = require("./../middleware.api");
class PassportClient {
    constructor(strategy) {
        this.passport = passport_1.default;
        this.strategy = strategy;
        this.passport.serializeUser((user, done) => {
            done(null, user);
        });
        this.passport.deserializeUser((user, done) => {
            done(null, user);
        });
        this.passport.use(strategy);
        PassportClient.LOGGER.info(`Using authentication strategy: ${strategy.name} `);
    }
    init(app) {
        app.use(this.passport.initialize());
        app.use(this.passport.session());
    }
    createMiddleware(options = {}) {
        return this.passport.authenticate(this.strategy.name, options);
    }
}
exports.PassportClient = PassportClient;
PassportClient.LOGGER = middleware_api_1.middlewareLogger;
