"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleGraphQL = void 0;
const apollo_server_express_1 = require("apollo-server-express");
/* eslint-disable */
//errors with normal import, have to use require
//that or allow implicit any
const { graphqlUploadExpress } = require("graphql-upload");
const middleware_api_1 = require("./middleware.api");
// TODO investigate why app Application type does not match with apollo's version
const handleGraphQL = (app, graphQLConfig) => {
    middleware_api_1.logMiddlewareStart("GraphQL");
    const path = `/${graphQLConfig.rootPath}`;
    const options = Object.assign({
        typeDefs: graphQLConfig.typeDefs,
        resolvers: graphQLConfig.resolvers,
    }, graphQLConfig.context && { context: graphQLConfig.context }, 
    //https://www.apollographql.com/docs/apollo-server/v2/data/file-uploads/
    //to allow compatibility with node 14 and apollo server 2
    graphQLConfig.uploads !== undefined && { uploads: graphQLConfig.uploads });
    const server = new apollo_server_express_1.ApolloServer(options);
    app.use(graphqlUploadExpress());
    server.applyMiddleware({ app, path });
};
exports.handleGraphQL = handleGraphQL;
