"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorMiddleware = void 0;
const config_1 = require("../config");
const login_middleware_1 = require("./auth/login.middleware");
const verification_middleware_1 = require("./auth/verification.middleware");
const common_middleware_1 = require("./common.middleware");
const httpGuard_middleware_1 = require("./httpGuard.middleware");
const metrics_middleware_1 = require("./metrics.middleware");
const requestId_middleware_1 = require("./requestId.middleware");
const session_middleware_1 = require("./session.middleware");
// Optional Middleware
__exportStar(require("./serveStaticContent.middleware"), exports);
__exportStar(require("./logger.middleware"), exports);
var errorHandler_middleware_1 = require("./errorHandler.middleware");
Object.defineProperty(exports, "errorMiddleware", { enumerable: true, get: function () { return __importDefault(errorHandler_middleware_1).default; } });
// Optional Clients
__exportStar(require("./client/MongoClient"), exports);
// Pre routes middleware
exports.default = [
    common_middleware_1.handleCors,
    common_middleware_1.handleBodyRequestParsing,
    common_middleware_1.handleCompression,
    metrics_middleware_1.handleMetrics,
    requestId_middleware_1.handleRequestId,
    httpGuard_middleware_1.handleHttpGuard,
    session_middleware_1.handleSessions,
    ...(config_1.baseConfig.app.requireLogin ? [login_middleware_1.handleLogin] : []),
    verification_middleware_1.handleAuthVerification,
];
