"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleMetrics = void 0;
const express_prom_bundle_1 = __importDefault(require("express-prom-bundle"));
const middleware_api_1 = require("./middleware.api");
/**
 * Adds metrics to the app
 *
 * The order in which the routes are registered is important, since only the routes registered after the express-prom-bundle will be measured
 * You can use this to your advantage to bypass some of the routes
 *
 *  @param router
 */
const handleMetrics = (router) => {
    const options = {
        includeMethod: true,
        autoregister: true, // if /metrics endpoint should be registered
    };
    const promethiusMiddleware = express_prom_bundle_1.default(options);
    middleware_api_1.logMiddlewareStart("Metrics");
    router.use(promethiusMiddleware);
};
exports.handleMetrics = handleMetrics;
