"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommonServicesProvider = void 0;
const __1 = require("../../..");
const common_1 = require("../../../common");
class CommonServicesProvider extends common_1.AbstractRestProvider {
    constructor() {
        var _a;
        super(...arguments);
        this.apiUrl = (_a = __1.ApplicationConfig.get().common) === null || _a === void 0 ? void 0 : _a.servicesApi;
    }
    /**
     * Retrieves the record for the application requested
     * @param id - String representing the id of the service to be retireved (application name)
     * @returns {Promise<CommonServicesAPIRecord>}
     */
    getServiceById(id) {
        const config = __1.ApplicationConfig.get();
        const options = {
            headers: __1.HttpApiJsonRequester.basicAuth(config.basicAuth.username, config.basicAuth.pass),
        };
        return this.requester.fetchJson(`${this.apiUrl}/service?serviceId=${id}`, options);
    }
}
exports.CommonServicesProvider = CommonServicesProvider;
