"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IesTemplateServer = void 0;
const app_1 = require("./app");
const common_1 = require("./common");
const config_1 = require("./config");
const server_1 = require("./server");
const utils_1 = require("./utils");
/**
 * IES Template Server
 *
 * It is designed to reduce boilerplate in projects that use this project by
 * only requiring routes as a dependency since all the business logic is
 * encapsulated behind a route.
 */
class IesTemplateServer {
    constructor(routes, httpsOptions, middlewareOptions) {
        IesTemplateServer.LOGGER.info(utils_1.removeSecretsFromConfig(config_1.baseConfig));
        const applicationManager = new app_1.ApplicationManager(routes, config_1.baseConfig.app, middlewareOptions);
        const appServerConfig = {
            port: config_1.baseConfig.app.port,
            https: httpsOptions,
        };
        this.applicationServer = new server_1.ApplicationServer(applicationManager, appServerConfig);
    }
    start() {
        this.applicationServer.start();
    }
}
exports.IesTemplateServer = IesTemplateServer;
IesTemplateServer.LOGGER = common_1.logger.child("IesServer");
