import coreMiddleware, { errorMiddleware } from "./middleware";
import { AppFactory } from "./utils/app.utils";
import { ApiRouterFactory } from "./utils/route.utils";
export class ApplicationManager {
    constructor(routes, config, middlewareOptions) {
        const router = ApiRouterFactory.makeRouter(routes);
        this.application = AppFactory.createExpressApp(config, router, coreMiddleware, errorMiddleware, middlewareOptions);
    }
    app() {
        return this.application;
    }
}
