import { validate } from "class-validator";
export class Model {
    constructor(id) {
        if (id)
            this.id = id;
    }
    set(data) {
        if (data == null) {
            return;
        }
        for (const key in data) {
            if (this.hasOwnProperty(key) && key !== "id") {
                // Typescript Issue Resolution: https://stackoverflow.com/questions/40358434/typescript-ts7015-element-implicitly-has-an-any-type-because-index-expression
                this[key] = data[key];
            }
        }
    }
    _validate(obj) {
        return validate(obj);
    }
    validate() {
        return this._validate(this);
    }
    isValid() {
        return this._validate(this).then((errors) => errors.length === 0);
    }
    isNew() {
        return this.id == null;
    }
    toJSON() {
        if (this.id)
            return { id: this.id };
        return {};
    }
}
