export class ExternalApiError extends Error {
    constructor(api, status, message) {
        if (message instanceof Object) {
            super(JSON.stringify(message));
        }
        else {
            super(message);
        }
        this.api = api;
        this.statusCode = status;
        this.name = this.constructor.name;
        Error.captureStackTrace(this, this.constructor);
    }
}
ExternalApiError.factory =
    (api) => (status, message) => new ExternalApiError(api, status, message);
