import { Router } from "express";
export class AbstractRestRouter {
    constructor() {
        this.router = Router();
    }
    getBasePath() {
        return this.basePath;
    }
    getRouter() {
        return this.router;
    }
    handleRouteParam(controller, handler) {
        return (req, res, next, param) => {
            return Promise.resolve(handler.bind(controller)(req, res, next, param)).catch((err) => next(err));
        };
    }
    handleRoute(controller, handler) {
        return (req, res, next) => {
            const noParam = "";
            return Promise.resolve(handler.bind(controller)(req, res, next, noParam)).catch((err) => next(err));
        };
    }
}
