var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { baseConfig } from "../../../config";
import { AbstractRestController, logger } from "../..";
import { TokenProvider } from "./providers";
import { Token } from "./token.model";
export class ProxyController extends AbstractRestController {
    // JWT cannot be retrieved by the client, as the client secret needs to be added on the server and CORS errors prevent calling cross-domain
    getToken(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            ProxyController.LOGGER.debug("Requesting token in oauth flow");
            const body = req.body;
            // Structure data to be sent as form data
            let searchParams = Object.keys(body)
                .map((key) => {
                return encodeURIComponent(key) + "=" + encodeURIComponent(body[key]);
            })
                .join("&");
            searchParams += `&client_secret=${baseConfig.openid.client_secret}`;
            const provider = new TokenProvider({}); // Auth not needed, default options
            const data = yield provider.getToken(searchParams);
            const token = new Token(data);
            return Promise.resolve(this.respond(res, token));
        });
    }
}
ProxyController.LOGGER = logger.child("Proxy");
