import { ObjectId } from "mongodb";
import { Model } from "../../data/model.api";
export declare class Notice extends Model {
    notice: string;
    startDate: Date;
    endDate: Date;
    offeringId: ObjectId;
    description: string;
    deleted: boolean;
    constructor(data: any);
    toJSON(): any;
}
/**
 * @swagger
 *  components:
 *    schemas:
 *      Notice:
 *        type: object
 *        properties:
 *          id:
 *            type: string
 *            example: 6102eaa24908dd09cddfee39
 *          notice:
 *            type: string
 *          startDate:
 *            type: string
 *            format: date
 *          endDate:
 *            type: string
 *            format: date
 *          offeringId:
 *            type: string
 *            example: 6102eaa24908dd09cddfee39
 *          description:
 *            type: string
 *          deleted:
 *            type: boolean
 */
