var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { IsBoolean, IsDate, IsMongoId, IsString } from "class-validator";
import { ObjectId } from "mongodb";
import { Model } from "../../data/model.api";
export class Notice extends Model {
    constructor(data) {
        super(data === null || data === void 0 ? void 0 : data._id);
        this.notice = data === null || data === void 0 ? void 0 : data.notice;
        this.startDate = new Date(data === null || data === void 0 ? void 0 : data.startDate);
        this.endDate = new Date(data === null || data === void 0 ? void 0 : data.endDate);
        this.offeringId = new ObjectId(data === null || data === void 0 ? void 0 : data.offeringId);
        this.description = data === null || data === void 0 ? void 0 : data.description;
        this.deleted = data.deleted ? data.deleted : false;
    }
    toJSON() {
        return {
            id: this.id,
            notice: this.notice,
            startDate: this.startDate,
            endDate: this.endDate,
            offeringId: this.offeringId,
            description: this.description,
        };
    }
}
__decorate([
    IsString(),
    __metadata("design:type", String)
], Notice.prototype, "notice", void 0);
__decorate([
    IsDate(),
    __metadata("design:type", Date)
], Notice.prototype, "startDate", void 0);
__decorate([
    IsDate(),
    __metadata("design:type", Date)
], Notice.prototype, "endDate", void 0);
__decorate([
    IsMongoId(),
    __metadata("design:type", ObjectId)
], Notice.prototype, "offeringId", void 0);
__decorate([
    IsString(),
    __metadata("design:type", String)
], Notice.prototype, "description", void 0);
__decorate([
    IsBoolean(),
    __metadata("design:type", Boolean)
], Notice.prototype, "deleted", void 0);
/**
 * @swagger
 *  components:
 *    schemas:
 *      Notice:
 *        type: object
 *        properties:
 *          id:
 *            type: string
 *            example: 6102eaa24908dd09cddfee39
 *          notice:
 *            type: string
 *          startDate:
 *            type: string
 *            format: date
 *          endDate:
 *            type: string
 *            format: date
 *          offeringId:
 *            type: string
 *            example: 6102eaa24908dd09cddfee39
 *          description:
 *            type: string
 *          deleted:
 *            type: boolean
 */
