import { ObjectId } from "mongodb";
import { HttpApiJsonRequester } from "../../../..";
import { ApplicationConfig } from "../../../../config";
import { AbstractRestProvider } from "../../..";
export class SiteNoticeProvider extends AbstractRestProvider {
    constructor() {
        var _a, _b, _c, _d;
        super(...arguments);
        this.apiUrl = (_b = (_a = ApplicationConfig.get()) === null || _a === void 0 ? void 0 : _a.dashboardService) === null || _b === void 0 ? void 0 : _b.api;
        this.offeringId = (_d = (_c = ApplicationConfig.get()) === null || _c === void 0 ? void 0 : _c.dashboardService) === null || _d === void 0 ? void 0 : _d.offeringId;
    }
    getNotices() {
        const body = {
            startDate: {
                date: new Date().toISOString(),
                filter: "$lte",
            },
            endDate: {
                date: new Date().toISOString(),
                filter: "$gte",
            },
            offeringId: new ObjectId(this.offeringId),
            deleted: false,
        };
        const options = HttpApiJsonRequester.postJson(body);
        return this.requester.fetchJson(`${this.apiUrl}/notices/search`, options);
    }
}
