var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { AbstractRestController, logger } from "../..";
import { Notices } from "./Notices.model";
import { SiteNoticeProvider } from "./providers";
export class SiteNoticeController extends AbstractRestController {
    getSiteNotices(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            SiteNoticeController.LOGGER.debug("Retrieving all Site Notices");
            const noticeProvider = new SiteNoticeProvider({});
            const noticesMongo = yield noticeProvider.getNotices();
            const notices = new Notices(noticesMongo);
            return Promise.resolve(this.respond(res, notices));
        });
    }
}
SiteNoticeController.LOGGER = logger.child("Site Notice");
