/// <reference types="passport" />
/**
 * @example <caption> W3ID Auth User Type </caption>
 * @see {@link "../../middleware/auth/"}
 */
declare type W3ID_AUTH_USER = {
    id?: string;
    _json: {
        sub: string;
        at_hash: string;
        realmName: string;
        iss: string;
        aud: string;
        exp: number;
        iat: number;
        emailAddress: string;
        lastName: string;
        blueGroups: string[];
        cn: string;
        dn: string;
        uid: string;
        firstName: string;
        accessToken: string;
        refreshToken: string;
    };
};
/**
 * AuthUser that encompasses node express and w3id user attributes
 */
export declare type AuthUser = Express.User & W3ID_AUTH_USER;
export {};
