import passportCiOidc from "passport-ci-oidc";
import { baseConfig } from "../../../config";
const OpenIDConnectStrategy = passportCiOidc.IDaaSOIDCStrategy;
export const W3_OIDC_STRATEGY = new OpenIDConnectStrategy({
    discoveryURL: baseConfig.openid.discovery_url,
    clientID: baseConfig.openid.client_id,
    scope: "openid",
    response_type: "code",
    clientSecret: baseConfig.openid.client_secret,
    callbackURL: baseConfig.openid.callback_url,
    skipUserProfile: true,
    addCACert: true,
    // local: true,
    CACertPathList: [
        "/cert/DigiCertGlobalRootCA.crt",
        "/cert/DigiCertSHA2SecureServerCA.crt",
    ],
}, (iss, sub, profile, accessToken, refreshToken, params, done) => {
    process.nextTick(() => {
        // pass access token into jwt
        profile._json.accessToken = accessToken;
        profile._json.refreshToken = refreshToken;
        return done(null, profile);
    });
});
