var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { IsEmail } from "class-validator";
import { Model } from "../../common/data/model.api";
import { isAdministrator, isAuditor, isAuthorizedUser, isDevOps, isExternal, isHelpDeskUser, isPO, isTeamMember, } from "../../utils/auth.utils";
export class AuthenticatedUser extends Model {
    constructor(data) {
        super(data.id);
        const { blueGroups, firstName, lastName, emailAddress } = data._json;
        this._firstName = firstName;
        this._lastName = lastName;
        this._email = emailAddress;
        this._isAdmin = isAdministrator(blueGroups);
        this._isAuthorized = isAuthorizedUser(blueGroups);
        this._isAuditor = isAuditor(blueGroups);
        this._isDevOps = isDevOps(blueGroups);
        this._isPO = isPO(blueGroups);
        this._isExternal = isExternal(blueGroups);
        this._isTeamMember = isTeamMember(blueGroups);
        this._isHelpDesk = isHelpDeskUser(blueGroups);
    }
    get email() {
        return this._email;
    }
    get isAuthorized() {
        return this._isAuthorized;
    }
    get isAdmin() {
        return this._isAdmin;
    }
    toJSON() {
        return {
            id: this.id,
            firstName: this._firstName,
            lastName: this._lastName,
            isAdmin: this._isAdmin,
            isAuditor: this._isAuditor,
            isDevOps: this._isDevOps,
            isPO: this._isPO,
            isExternal: this._isExternal,
            isTeamMember: this._isTeamMember,
            isHelpDeskUser: this._isHelpDesk,
        };
    }
}
__decorate([
    IsEmail(),
    __metadata("design:type", String)
], AuthenticatedUser.prototype, "_email", void 0);
