import Passport from "passport";
import { middlewareLogger } from "./../middleware.api";
export class PassportClient {
    constructor(strategy) {
        this.passport = Passport;
        this.strategy = strategy;
        this.passport.serializeUser((user, done) => {
            done(null, user);
        });
        this.passport.deserializeUser((user, done) => {
            done(null, user);
        });
        this.passport.use(strategy);
        PassportClient.LOGGER.info(`Using authentication strategy: ${strategy.name} `);
    }
    init(app) {
        app.use(this.passport.initialize());
        app.use(this.passport.session());
    }
    createMiddleware(options = {}) {
        return this.passport.authenticate(this.strategy.name, options);
    }
}
PassportClient.LOGGER = middlewareLogger;
