import parser from "body-parser";
import compression from "compression";
import cors from "cors";
import { logMiddlewareStart } from "./middleware.api";
export const handleCors = (router) => {
    logMiddlewareStart("Cors");
    router.use(cors({ credentials: true, origin: true }));
};
export const handleBodyRequestParsing = (router) => {
    logMiddlewareStart("Json Body Parsing");
    router.use(parser.urlencoded({ extended: true }));
    router.use(parser.json());
};
export const handleCompression = (router) => {
    logMiddlewareStart("Compression");
    router.use(compression());
};
