import { ApolloServer } from "apollo-server-express";
/* eslint-disable */
//errors with normal import, have to use require
//that or allow implicit any
const { graphqlUploadExpress } = require("graphql-upload");
import { logMiddlewareStart } from "./middleware.api";
// TODO investigate why app Application type does not match with apollo's version
export const handleGraphQL = (app, graphQLConfig) => {
    logMiddlewareStart("GraphQL");
    const path = `/${graphQLConfig.rootPath}`;
    const options = Object.assign({
        typeDefs: graphQLConfig.typeDefs,
        resolvers: graphQLConfig.resolvers,
    }, graphQLConfig.context && { context: graphQLConfig.context }, 
    //https://www.apollographql.com/docs/apollo-server/v2/data/file-uploads/
    //to allow compatibility with node 14 and apollo server 2
    graphQLConfig.uploads !== undefined && { uploads: graphQLConfig.uploads });
    const server = new ApolloServer(options);
    app.use(graphqlUploadExpress());
    server.applyMiddleware({ app, path });
};
