import { baseConfig } from "../config";
import { handleLogin } from "./auth/login.middleware";
import { handleAuthVerification } from "./auth/verification.middleware";
import { handleBodyRequestParsing, handleCompression, handleCors, } from "./common.middleware";
import { handleHttpGuard } from "./httpGuard.middleware";
import { handleMetrics } from "./metrics.middleware";
import { handleRequestId } from "./requestId.middleware";
import { handleSessions } from "./session.middleware";
// Optional Middleware
export * from "./serveStaticContent.middleware";
export * from "./logger.middleware";
export { default as errorMiddleware } from "./errorHandler.middleware";
// Optional Clients
export * from "./client/MongoClient";
// Pre routes middleware
export default [
    handleCors,
    handleBodyRequestParsing,
    handleCompression,
    handleMetrics,
    handleRequestId,
    handleHttpGuard,
    handleSessions,
    ...(baseConfig.app.requireLogin ? [handleLogin] : []),
    handleAuthVerification,
];
