import promBundle from "express-prom-bundle";
import { logMiddlewareStart } from "./middleware.api";
/**
 * Adds metrics to the app
 *
 * The order in which the routes are registered is important, since only the routes registered after the express-prom-bundle will be measured
 * You can use this to your advantage to bypass some of the routes
 *
 *  @param router
 */
export const handleMetrics = (router) => {
    const options = {
        includeMethod: true,
        autoregister: true, // if /metrics endpoint should be registered
    };
    const promethiusMiddleware = promBundle(options);
    logMiddlewareStart("Metrics");
    router.use(promethiusMiddleware);
};
