import { v5 as uuidv5 } from "uuid";
import { logMiddlewareStart } from "./middleware.api";
export const handleRequestId = (router) => {
    const HEADER_NAME = "X-Request-Id";
    logMiddlewareStart("Request Id");
    router.use((req, res, next) => {
        const reqWithId = req;
        reqWithId.id =
            req.headers[HEADER_NAME.toLowerCase()] || uuidv5(req.url, uuidv5.URL);
        res.setHeader(HEADER_NAME, reqWithId.id);
        next();
    });
};
