import { ApplicationConfig, HttpApiJsonRequester } from "../../..";
import { AbstractRestProvider } from "../../../common";
export class CommonServicesProvider extends AbstractRestProvider {
    constructor() {
        var _a;
        super(...arguments);
        this.apiUrl = (_a = ApplicationConfig.get().common) === null || _a === void 0 ? void 0 : _a.servicesApi;
    }
    /**
     * Retrieves the record for the application requested
     * @param id - String representing the id of the service to be retireved (application name)
     * @returns {Promise<CommonServicesAPIRecord>}
     */
    getServiceById(id) {
        const config = ApplicationConfig.get();
        const options = {
            headers: HttpApiJsonRequester.basicAuth(config.basicAuth.username, config.basicAuth.pass),
        };
        return this.requester.fetchJson(`${this.apiUrl}/service?serviceId=${id}`, options);
    }
}
