/// <reference types="node" />
import https from "https";
import { RestRouter } from "./common";
import { MiddlewareOptions } from "./utils/app.utils";
export interface TemplateServer {
    start(): void;
}
/**
 * IES Template Server
 *
 * It is designed to reduce boilerplate in projects that use this project by
 * only requiring routes as a dependency since all the business logic is
 * encapsulated behind a route.
 */
export declare class IesTemplateServer implements TemplateServer {
    private applicationServer;
    private static readonly LOGGER;
    constructor(routes: RestRouter[], httpsOptions?: https.ServerOptions, middlewareOptions?: MiddlewareOptions);
    start(): void;
}
