import { ApplicationManager } from "./app";
import { logger } from "./common";
import { baseConfig } from "./config";
import { ApplicationServer } from "./server";
import { removeSecretsFromConfig } from "./utils";
/**
 * IES Template Server
 *
 * It is designed to reduce boilerplate in projects that use this project by
 * only requiring routes as a dependency since all the business logic is
 * encapsulated behind a route.
 */
export class IesTemplateServer {
    constructor(routes, httpsOptions, middlewareOptions) {
        IesTemplateServer.LOGGER.info(removeSecretsFromConfig(baseConfig));
        const applicationManager = new ApplicationManager(routes, baseConfig.app, middlewareOptions);
        const appServerConfig = {
            port: baseConfig.app.port,
            https: httpsOptions,
        };
        this.applicationServer = new ApplicationServer(applicationManager, appServerConfig);
    }
    start() {
        this.applicationServer.start();
    }
}
IesTemplateServer.LOGGER = logger.child("IesServer");
