import mongoose from "mongoose";
declare class MongoMemoryClient {
    private mongod;
    private connection;
    private connectToDB;
    private setConnection;
    /**
     * replaces 'id' with '_id' prop with values of 'new ObjectId(data.id);'
     *
     * @param {Object}data document to be inserted
     * @returns {Object} document to be inserted with mongo id
     */
    private addSeededMongoId;
    getConnection(): Promise<mongoose.Connection>;
    /**
     * adds data to the specified collection
     *
     * @param {string} collectionName
     * @param {object} data data to be seeded to the specified collection
     */
    seedCollection(collectionName: string, data: any): Promise<void>;
    /**
     * deletes all of the collections created
     */
    clearDatabase(): Promise<import("mongodb").DeleteResult[]>;
    /**
     * closes connection with db
     */
    closeDatabase(): Promise<void>;
}
export declare const mongoMemoryClient: MongoMemoryClient;
export {};
