import { Express, NextFunction, Request, Response, Router } from "express";
import { Options } from "swagger-jsdoc";
import { AppConfig, GraphQLConfig } from "../config/env.config";
import { MiddlewareConfigurer } from "../middleware/middleware.api";
export declare type CustomExpressMiddleware = (req: Request, res: Response, next: NextFunction) => void;
export interface MiddlewareOptions {
    graphQLConfig?: GraphQLConfig;
    swagger?: {
        config: Options;
        uiOptions?: Record<string, unknown>;
    };
    preApiRouterMiddleware?: Record<string, unknown>;
    customServeStaticMiddleware?: CustomExpressMiddleware[];
}
export declare class AppFactory {
    private static readonly LOGGER;
    static createExpressApp(appConfig: AppConfig, apiRouter: Router, preApiRouterMiddleware: MiddlewareConfigurer[], postApiRouterMiddleware: MiddlewareConfigurer[], middlewareOptions?: MiddlewareOptions): Express;
}
