import { baseConfig } from "../config/env.config";
/**
 * Determimes if the configured application bluegroups
 * contains a role that matches the provided bluegroups
 *
 * Hueristic Optimization:
 * - outer loop is config based since majority of
 *   time its a smaller size than the queried bluegroups
 *
 * @param bluegroups a list of IBM internal roles
 */
export const isAdministrator = (bluegroups) => baseConfig.bluegroups.admin.some((role) => bluegroups.includes(role));
/**
 * Is the user authorized to use the application
 * @param bluegroups a list of IBM internal roles
 */
export const isAuthorizedUser = (bluegroups) => {
    var _a;
    if (baseConfig.bluegroups.bypassAppUserAuth) {
        return true;
    }
    return (_a = baseConfig.bluegroups) === null || _a === void 0 ? void 0 : _a.appUser.some((role) => bluegroups.includes(role));
};
export const isAuditor = (bluegroups) => {
    var _a;
    return (_a = baseConfig.bluegroups) === null || _a === void 0 ? void 0 : _a.auditor.some((role) => bluegroups.includes(role));
};
export const isDevOps = (bluegroups) => {
    var _a;
    return (_a = baseConfig.bluegroups) === null || _a === void 0 ? void 0 : _a.devOps.some((role) => bluegroups.includes(role));
};
export const isPO = (bluegroups) => { var _a; return (_a = baseConfig.bluegroups) === null || _a === void 0 ? void 0 : _a.po.some((role) => bluegroups.includes(role)); };
export const isExternal = (bluegroups) => {
    var _a;
    return (_a = baseConfig.bluegroups) === null || _a === void 0 ? void 0 : _a.external.some((role) => bluegroups.includes(role));
};
export const isTeamMember = (bluegroups) => {
    var _a;
    return (_a = baseConfig.bluegroups) === null || _a === void 0 ? void 0 : _a.teamMember.some((role) => bluegroups.includes(role));
};
export const isHelpDeskUser = (bluegroups) => {
    var _a;
    return (_a = baseConfig.bluegroups) === null || _a === void 0 ? void 0 : _a.helpDesk.some((role) => bluegroups.includes(role));
};
