import { Router } from "express";
import { logger } from "../common";
import { baseConfig } from "../config";
export class ApiRouterFactory {
    static makeRouter(restRouters) {
        this.LOGGER.info(`Creating Router`.toUpperCase());
        const router = Router();
        restRouters.forEach((restRoute) => {
            this.LOGGER.info(`Adding Route: ${restRoute.getBasePath()}`);
            router.use(restRoute.getBasePath(), restRoute.getRouter());
        });
        return router;
    }
}
ApiRouterFactory.LOGGER = logger.child("Router Factory");
/**
 * Checks if the request is a /api request
 * @param req
 */
export const isApiRequest = (req) => req.baseUrl === baseConfig.app.apiBasePath || // set if route is mounted
    req.url.startsWith(baseConfig.app.apiBasePath);
