/// <reference types="jest" />
import { Application } from "express";
import { RestRouter } from "../common/rest/restRouter.api";
import { MiddlewareConfigurer } from "./../middleware/middleware.api";
export declare const createRouterTestPath: (restRouter: RestRouter, testPath?: string) => string;
export declare const createRouterTestApp: (restRouter: RestRouter) => Application;
export declare const createSecureMiddlewareRouterTestApp: (...middleware: MiddlewareConfigurer[]) => Application;
export declare const createSecureRouterTestApp: (restRouter: RestRouter) => Application;
declare type MockResponse = {
    status: jest.MockedFunction<any>;
    json: jest.MockedFunction<any>;
    send: jest.MockedFunction<any>;
};
export declare const mockResponse: () => MockResponse;
/**
 * Sets up common jest app needs globally
 * Note: "any" type must be used in ensureAuthenticated in order
 *       to do the object assignments
 */
export declare const setupGlobals: () => void;
export {};
