# eslint-config-ies-node-typescript

A typescript node linter with prettier formatting integration

## Usage

To use this library in your react project, ensure the following:

First time setup:

1. Go to [Artifactory](https://na.artifactory.swg-devops.com/artifactory/webapp/#/home)
1. Set Me Up
1. `fxo-cio-ies-npm-virtual`
1. Follow the instructions. You can put in your global .npmrc or in project. This acts as a proxy to the npm public repository in addition to our internal repository.

Standard setup:

1. Using your configured package manager, install `@ies/eslint-config-react`
2. In your eslint configuration file, add to `extends` array `"@ies/eslint-config-react-test"`
3. Eslint, unlike tslint (depricated), does not pull in type checking from your tsconfig file. Modify your `package.json` lint script to handle this. Here are some example modifications:

```
"check-types": "tsc -p tsconfig.lint.json --noemit",
"lint": "npx eslint {regex} --quiet --fix && npm run check-types",
```

Modify the {regex} to cover your source files.

Note that I created a separate tsconfig file for linting because
it doesn't work with incremental builds so I disabled it:

```
{
  "extends": "./tsconfig.json",
  "compilerOptions": {
    "incremental": false
  }
}
```

If you don't work with incremental builds, then a custom config is not necessary and the `-p` option can be removed.

## Contributing

### Caveats

The plugin:prettier/recommended must be the last configuration in the extends array in order to ensure prettier can be run with eslint. The advantage of having prettier setup as an ESLint rule using eslint-plugin-prettier is that code can automatically be fixed using ESLint's --fix option.
