import { ApplicationConfig, getStringEnvVar, logger, LoggerApi } from ".";

// NOBUG: The application config needs to be read into memory BEFORE getRoutes is read
// If not, then it cannot read the new config variables in time... We create a file with
// a name that is near the top of the alphabet and import it for its side effects only...

const LOGGER: LoggerApi = logger.child("Custom-Config");

LOGGER.info("Applying custom config");

ApplicationConfig.enableMaintenanceMode(
  getStringEnvVar("SERVICES_API"),
  getStringEnvVar("POLICIES_USERNAME"),
  getStringEnvVar("POLICIES_PASSWORD"),
  getStringEnvVar("SERVICE_ID")
);
