import { Model } from "../data/model.api";

export interface CrudService<T extends Model> {
  getAll(): Promise<T[]>;
  get(id: string): Promise<T | null>;
  create(item: T): Promise<T>;
  update(id: string, newItem: T): Promise<T>;
  delete(id: string): Promise<void>;
}
