import { JsonSerializer } from "../../data";

export abstract class HTTPClientError extends Error implements JsonSerializer {
  readonly statusCode!: number;
  readonly name!: string;

  constructor(message: Record<string, unknown> | string) {
    if (message instanceof Object) {
      super(JSON.stringify(message));
    } else {
      super(message);
    }
    this.name = this.constructor.name;
    Error.captureStackTrace(this, this.constructor);
  }

  toJSON(): Record<string, unknown> {
    return {
      statusCode: this.statusCode,
      message: this.message,
    };
  }
}
