import { getStatusText, METHOD_NOT_ALLOWED } from "http-status-codes";

import { HTTPClientError } from "./error.api";

export class HTTP405Error extends HTTPClientError {
  readonly statusCode = METHOD_NOT_ALLOWED;

  constructor(
    message: string | Record<string, unknown> = getStatusText(
      METHOD_NOT_ALLOWED
    )
  ) {
    super(message);
  }
}
