import { RequestInit } from "node-fetch";

import {
  APIRequester,
  HttpApiJsonRequester,
} from "./../../utils/api/apiRequester.utils";

// eslint-disable: max-classes-per-file
export abstract class AbstractRestProvider {
  protected readonly apiUrl!: string;
  protected readonly requester: APIRequester;

  protected defaultRequestOptions!: RequestInit;

  constructor(options: RequestInit) {
    const allOptions = {
      ...this.defaultRequestOptions,
      ...options,
    };
    this.requester = new HttpApiJsonRequester(
      this.constructor.name,
      allOptions
    );
  }
}

export abstract class AbstractSecureRestProvider extends AbstractRestProvider {
  constructor(accessToken: string) {
    super({
      headers: HttpApiJsonRequester.oauth2Header(accessToken),
    });
  }
}
