import { AbstractRestRouter } from "../..";
import { ProxyController } from "./proxy.controller";
import { Token } from "./token.model";

export class ProxyRouter extends AbstractRestRouter<Token, ProxyController> {
  protected readonly basePath = "/proxy/oidc/endpoint/default/token";
  private readonly controller: ProxyController;

  constructor() {
    super();
    this.controller = new ProxyController();
    this.initRoutes();
  }

  initRoutes(): void {
    const c = this.controller;

    this.router.post("/", this.handleRoute(c, c.getToken));
  }
}
