import { Model } from "../../data/model.api";
import { Notice } from "./Notice.model";

export class Notices extends Model {
  notices: Notice[] = [];

  constructor(data: any) {
    super(data.id);
    this.notices = this._modelNotices(data);
  }

  // Takes in an an array of notices (unmodeled), need type any to avoid property map does not exist error
  _modelNotices(notices: any): Notice[] {
    return notices.map((notice: Notice) => {
      return new Notice(notice);
    });
  }

  toJSON(): any {
    return {
      notices: this.notices,
    };
  }
}

/**
 * @swagger
 *  components:
 *    schemas:
 *      Notices:
 *        type: object
 *        properties:
 *          notices:
 *            type: array
 *            items:
 *              $ref: '#/components/schemas/Notice'
 */
