import { ObjectId } from "mongodb";

import { HttpApiJsonRequester } from "../../../..";
import { ApplicationConfig } from "../../../../config";
import { AbstractRestProvider } from "../../..";

export class SiteNoticeProvider extends AbstractRestProvider {
  protected readonly apiUrl = ApplicationConfig.get()?.dashboardService?.api;
  protected readonly offeringId =
    ApplicationConfig.get()?.dashboardService?.offeringId;

  getNotices(): Promise<any> {
    const body = {
      startDate: {
        date: new Date().toISOString(),
        filter: "$lte",
      },
      endDate: {
        date: new Date().toISOString(),
        filter: "$gte",
      },
      offeringId: new ObjectId(this.offeringId),
      deleted: false,
    };

    const options = HttpApiJsonRequester.postJson(body);

    return this.requester.fetchJson(`${this.apiUrl}/notices/search`, options);
  }
}
