import { Request, Response } from "express";

import { AbstractRestController, logger, LoggerApi } from "../..";
import { Notices } from "./Notices.model";
import { SiteNoticeProvider } from "./providers";

export class SiteNoticeController extends AbstractRestController<Notices> {
  private static readonly LOGGER: LoggerApi = logger.child("Site Notice");

  async getSiteNotices(req: Request, res: Response): Promise<any> {
    SiteNoticeController.LOGGER.debug("Retrieving all Site Notices");

    const noticeProvider = new SiteNoticeProvider({});
    const noticesMongo = await noticeProvider.getNotices();
    const notices = new Notices(noticesMongo);

    return Promise.resolve(this.respond(res, notices));
  }
}
