import { HttpApiJsonRequester } from "../../utils/api/apiRequester.utils";

// TODO refactor into router / service framework along with the other verification middleware
// TODO need to create return type, interface, and/or model
const validateUserWithServiceIdApi = async (
  email: string | undefined,
  config: any
): Promise<{ accept: boolean; redirectUrl: string }> => {
  const basicAuth = HttpApiJsonRequester.basicAuth(
    config.basicAuth.username,
    config.basicAuth.pass
  );

  const policiesRequester = new HttpApiJsonRequester("policies", {
    headers: basicAuth,
  });

  return policiesRequester.fetchJson(
    `${config.common.policiesApi}/user/service/?email=${email}&serviceId=${config.common.serviceId}`
  ) as Promise<{ accept: boolean; redirectUrl: string }>;
};

export { validateUserWithServiceIdApi };
