import parser from "body-parser";
import compression from "compression";
import cors from "cors";
import { Router } from "express";

import { logMiddlewareStart } from "./middleware.api";

export const handleCors = (router: Router) => {
  logMiddlewareStart("Cors");
  router.use(cors({ credentials: true, origin: true }));
};

export const handleBodyRequestParsing = (router: Router) => {
  logMiddlewareStart("Json Body Parsing");
  router.use(parser.urlencoded({ extended: true }));
  router.use(parser.json());
};

export const handleCompression = (router: Router) => {
  logMiddlewareStart("Compression");
  router.use(compression());
};
