import { ApolloServer } from "apollo-server-express";
import { graphqlUploadExpress } from "graphql-upload-minimal";

import { GraphQLConfig } from "../config";
import { logMiddlewareStart } from "./middleware.api";

// TODO investigate why app Application type does not match with apollo's version
export const handleGraphQL = async (app: any, graphQLConfig: GraphQLConfig) => {
  logMiddlewareStart("GraphQL");

  const path = `/${graphQLConfig.rootPath}`;

  const options = Object.assign(
    {
      typeDefs: graphQLConfig.typeDefs,
      resolvers: graphQLConfig.resolvers,
    },
    graphQLConfig.context && { context: graphQLConfig.context },
    graphQLConfig.uploads !== undefined && { uploads: graphQLConfig.uploads }
  );

  const server = new ApolloServer(options);
  await server.start();
  app.use(graphqlUploadExpress());

  server.applyMiddleware({ app, path });
};
