import { AbstractRestRouter } from "../../common/rest/restRouter.api";
import { ensureAuthenticated } from "../../middleware/auth/auth.middleware";
import { AssociationController } from "./association.controller";
import { Association } from "./association.model";

export class AssociationRouter extends AbstractRestRouter<
  Association,
  AssociationController
> {
  protected readonly basePath = "/associations";
  private readonly controller: AssociationController;

  constructor() {
    super();
    this.controller = new AssociationController();
    this.initRoutes();
  }
  initRoutes() {
    const c = this.controller;
    this.router.get(
      "/",
      ensureAuthenticated,
      c.queryValidator(),
      this.handleRoute(c, c.getAssociations)
    );
  }
}
