import { Request, Response } from "express";

import { AbstractRestController, logger, LoggerApi } from "../../common";
import { CommonServicesRecord } from "./commonService.model";
import { CommonServicesProvider } from "./providers/commonServices.provider";

export class CommonController extends AbstractRestController<CommonServicesRecord> {
  private static readonly LOGGER: LoggerApi = logger.child("common");

  async getCommonServiceById(req: Request, res: Response): Promise<any> {
    CommonController.LOGGER.debug("Retrieving all CommonServicesRecords");

    const targetApplication = req.params.app;

    const commonServicesProvider = new CommonServicesProvider({});

    const data = await commonServicesProvider.getServiceById(targetApplication);

    const modeledRecord = new CommonServicesRecord(data);

    return Promise.resolve(this.respond(res, modeledRecord));
  }
}
