import { Document, Schema } from "mongoose";

import { GRAPH_CONNECTION } from "./graph.connections";

const GraphSchema = new Schema({
  name: { type: String },
});

export interface IGraph {
  name: string;
}

// Useful pattern when you declare virtual methods that dynamically add fields not in IGraph
// instead of 'extend Document' for IGraph
export interface IGraphDocument extends IGraph, Document {}

export const GraphModel = GRAPH_CONNECTION.model<IGraphDocument>(
  "Graph",
  GraphSchema
);
