import { GraphQLUpload } from "graphql-upload-minimal";

import { GraphModel, IGraphDocument } from "./graph.model";

export const graphResolver = {
  Upload: GraphQLUpload,

  Mutation: {
    singleUpload: async (root: any, args: { file: any }) => {
      const { createReadStream, filename, mimetype, encoding } =
        await args.file;

      // Invoking the `createReadStream` will return a Readable Stream.
      // See https://nodejs.org/api/stream.html#stream_readable_streams
      const stream = createReadStream();

      return { filename, mimetype, encoding };
    },
  },
  Query: {
    hello: async () => {
      const name = "Test";

      const Graph = new GraphModel({ name });

      await Graph.save();

      const graph: IGraphDocument | null = await GraphModel.findOne({
        name,
      }).exec();

      await Graph.delete();

      return graph?.name;
    },
  },
};
