import { ApplicationConfig } from "../../../config";
import {
  APIRequester,
  HttpApiJsonRequester,
} from "../../../utils/api/apiRequester.utils";

export default class GithubProvider {
  private readonly requester: APIRequester;
  private readonly api: string;

  constructor() {
    this.requester = new HttpApiJsonRequester("github");
    this.api = ApplicationConfig.get().api?.github;
  }
  async findOrg(org?: string) {
    return this.requester.fetchJson(`${this.api}/orgs/${org}`);
  }
}
