import { Connection } from "mongoose";

import { MongoClient } from "../middleware";
import { mongoMemoryClient } from "../testUtils/MongoMemoryClient";

export const getMongoConnection = (
  dbName = ""
): Connection | Promise<Connection> => {
  return process.env.isTest === "true"
    ? mongoMemoryClient.getConnection()
    : MongoClient.newConnection(dbName);
};
