import { parseBoolean, parseInteger } from "./string.utils";

describe("String Utils", () => {
  test("canary infrastructure", () => expect(true).toBeTruthy());

  describe("#parseBoolean", () => {
    const BOOL_STRING_TRUE = "true";

    const BOOL_STRING_FALSE = "false";

    const NOT_BOOL = "not a bool";

    it("should return true if the provided parameter is the string of a boolean value", () => {
      const PARSED_BOOL_STRING_TRUE = parseBoolean(BOOL_STRING_TRUE);

      const PARSED_BOOL_STRING_FALSE = parseBoolean(BOOL_STRING_FALSE);

      expect(
        PARSED_BOOL_STRING_TRUE === true && PARSED_BOOL_STRING_FALSE === false
      ).toBeTruthy();
    });
    it("should throw an error if the provided parameter is not the string of a boolean value", () => {
      const PARSED_NOT_BOOL_FUNC = () => {
        parseBoolean(NOT_BOOL);
      };
      expect(PARSED_NOT_BOOL_FUNC).toThrow(Error);
    });
  });
  describe("#parseInteger", () => {
    const INT_STRING_1 = "1";

    const INT_STRING_2 = "2";

    const NOT_STRING = "abc";

    it("should return true if the provided parameter is the string of an integer", () => {
      const PARSED_INT_STRING_1 = parseInteger(INT_STRING_1);

      const PARSED_INT_STRING_2 = parseInteger(INT_STRING_2);

      expect(
        PARSED_INT_STRING_1 === 1 && PARSED_INT_STRING_2 === 2
      ).toBeTruthy();
    });
    it("should throw an error if the provided parameter is not the string of an integer value", () => {
      const PARSED_NOT_STRING_FUNC = () => {
        parseInteger(NOT_STRING);
      };
      expect(PARSED_NOT_STRING_FUNC).toThrow(Error);
    });
  });
});
